/* sudoku-game.c generated by valac 0.25.4.4-19ea, the Vala compiler
 * generated from sudoku-game.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <string.h>


#define TYPE_SUDOKU_GAME (sudoku_game_get_type ())
#define SUDOKU_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_GAME, SudokuGame))
#define SUDOKU_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_GAME, SudokuGameClass))
#define IS_SUDOKU_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_GAME))
#define IS_SUDOKU_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_GAME))
#define SUDOKU_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_GAME, SudokuGameClass))

typedef struct _SudokuGame SudokuGame;
typedef struct _SudokuGameClass SudokuGameClass;
typedef struct _SudokuGamePrivate SudokuGamePrivate;

#define TYPE_SUDOKU_BOARD (sudoku_board_get_type ())
#define SUDOKU_BOARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_BOARD, SudokuBoard))
#define SUDOKU_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_BOARD, SudokuBoardClass))
#define IS_SUDOKU_BOARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_BOARD))
#define IS_SUDOKU_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_BOARD))
#define SUDOKU_BOARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_BOARD, SudokuBoardClass))

typedef struct _SudokuBoard SudokuBoard;
typedef struct _SudokuBoardClass SudokuBoardClass;

#define SUDOKU_GAME_TYPE_UNDO_ITEM (sudoku_game_undo_item_get_type ())
typedef struct _SudokuGameUndoItem SudokuGameUndoItem;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
typedef struct _SudokuBoardPrivate SudokuBoardPrivate;

#define TYPE_COORD (coord_get_type ())
typedef struct _Coord Coord;
#define _sudoku_game_undo_item_free0(var) ((var == NULL) ? NULL : (var = (sudoku_game_undo_item_free (var), NULL)))

struct _SudokuGame {
	GObject parent_instance;
	SudokuGamePrivate * priv;
	SudokuBoard* board;
	GTimer* timer;
};

struct _SudokuGameClass {
	GObjectClass parent_class;
};

struct _SudokuGameUndoItem {
	gint row;
	gint col;
	gint val;
};

struct _SudokuGamePrivate {
	GeeArrayList* undostack;
	GeeArrayList* redostack;
};

struct _Coord {
	gint row;
	gint col;
};

struct _SudokuBoard {
	GObject parent_instance;
	SudokuBoardPrivate * priv;
	gint* cells;
	gint cells_length1;
	gint cells_length2;
	gboolean* is_fixed;
	gint is_fixed_length1;
	gint is_fixed_length2;
	GeeSet* broken_coords;
	GeeList* coords_for_col;
	GeeList* coords_for_row;
	GeeMap* coords_for_block;
};

struct _SudokuBoardClass {
	GObjectClass parent_class;
};


static gpointer sudoku_game_parent_class = NULL;

GType sudoku_game_get_type (void) G_GNUC_CONST;
GType sudoku_board_get_type (void) G_GNUC_CONST;
static GType sudoku_game_undo_item_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static SudokuGameUndoItem* sudoku_game_undo_item_dup (const SudokuGameUndoItem* self);
static void sudoku_game_undo_item_free (SudokuGameUndoItem* self);
#define SUDOKU_GAME_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SUDOKU_GAME, SudokuGamePrivate))
enum  {
	SUDOKU_GAME_DUMMY_PROPERTY
};
gboolean sudoku_game_is_undostack_null (SudokuGame* self);
gboolean sudoku_game_is_redostack_null (SudokuGame* self);
SudokuGame* sudoku_game_new (SudokuBoard* board);
SudokuGame* sudoku_game_construct (GType object_type, SudokuBoard* board);
void sudoku_game_insert (SudokuGame* self, gint row, gint col, gint val);
gint sudoku_board_get (SudokuBoard* self, gint row, gint col);
void sudoku_game_update_undo (SudokuGame* self, gint row, gint col, gint old_val, gint new_val);
void sudoku_board_insert (SudokuBoard* self, gint row, gint col, gint val, gboolean is_fixed);
void sudoku_game_remove (SudokuGame* self, gint row, gint col);
void sudoku_board_remove (SudokuBoard* self, gint row, gint col, gboolean is_fixed);
void sudoku_game_undo (SudokuGame* self);
static void sudoku_game_apply_stack (SudokuGame* self, GeeArrayList** from, GeeArrayList** to);
void sudoku_game_redo (SudokuGame* self);
void sudoku_game_reset (SudokuGame* self);
gint sudoku_board_get_rows (SudokuBoard* self);
gint sudoku_board_get_cols (SudokuBoard* self);
GType coord_get_type (void) G_GNUC_CONST;
Coord* coord_dup (const Coord* self);
void coord_free (Coord* self);
void sudoku_game_cell_changed_cb (SudokuGame* self, gint row, gint col, gint old_val, gint new_val);
static void sudoku_game_add_to_stack (SudokuGame* self, GeeArrayList** stack, gint r, gint c, gint v);
gdouble sudoku_game_get_total_time_played (SudokuGame* self);
gdouble sudoku_board_get_previous_played_time (SudokuBoard* self);
static void g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void sudoku_game_finalize (GObject* obj);


gboolean sudoku_game_is_undostack_null (SudokuGame* self) {
	gboolean result = FALSE;
	GeeArrayList* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->undostack;
	_tmp1_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_ == 0;
	return result;
}


gboolean sudoku_game_is_redostack_null (SudokuGame* self) {
	gboolean result = FALSE;
	GeeArrayList* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->redostack;
	_tmp1_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_ == 0;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


SudokuGame* sudoku_game_construct (GType object_type, SudokuBoard* board) {
	SudokuGame * self = NULL;
	SudokuBoard* _tmp0_ = NULL;
	SudokuBoard* _tmp1_ = NULL;
	GTimer* _tmp2_ = NULL;
	GeeArrayList* _tmp3_ = NULL;
	GeeArrayList* _tmp4_ = NULL;
	g_return_val_if_fail (board != NULL, NULL);
	self = (SudokuGame*) g_object_new (object_type, NULL);
	_tmp0_ = board;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->board);
	self->board = _tmp1_;
	_tmp2_ = g_timer_new ();
	_g_timer_destroy0 (self->timer);
	self->timer = _tmp2_;
	_tmp3_ = gee_array_list_new (SUDOKU_GAME_TYPE_UNDO_ITEM, (GBoxedCopyFunc) sudoku_game_undo_item_dup, sudoku_game_undo_item_free, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->undostack);
	self->priv->undostack = _tmp3_;
	_tmp4_ = gee_array_list_new (SUDOKU_GAME_TYPE_UNDO_ITEM, (GBoxedCopyFunc) sudoku_game_undo_item_dup, sudoku_game_undo_item_free, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->redostack);
	self->priv->redostack = _tmp4_;
	return self;
}


SudokuGame* sudoku_game_new (SudokuBoard* board) {
	return sudoku_game_construct (TYPE_SUDOKU_GAME, board);
}


void sudoku_game_insert (SudokuGame* self, gint row, gint col, gint val) {
	gint old_val = 0;
	SudokuBoard* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	SudokuBoard* _tmp7_ = NULL;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->board;
	_tmp1_ = row;
	_tmp2_ = col;
	_tmp3_ = sudoku_board_get (_tmp0_, _tmp1_, _tmp2_);
	old_val = _tmp3_;
	_tmp4_ = row;
	_tmp5_ = col;
	_tmp6_ = val;
	sudoku_game_update_undo (self, _tmp4_, _tmp5_, old_val, _tmp6_);
	_tmp7_ = self->board;
	_tmp8_ = row;
	_tmp9_ = col;
	_tmp10_ = val;
	sudoku_board_insert (_tmp7_, _tmp8_, _tmp9_, _tmp10_, FALSE);
	_tmp11_ = row;
	_tmp12_ = col;
	_tmp13_ = val;
	g_signal_emit_by_name (self, "cell-changed", _tmp11_, _tmp12_, old_val, _tmp13_);
}


void sudoku_game_remove (SudokuGame* self, gint row, gint col) {
	gint old_val = 0;
	SudokuBoard* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	SudokuBoard* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->board;
	_tmp1_ = row;
	_tmp2_ = col;
	_tmp3_ = sudoku_board_get (_tmp0_, _tmp1_, _tmp2_);
	old_val = _tmp3_;
	_tmp4_ = row;
	_tmp5_ = col;
	sudoku_game_update_undo (self, _tmp4_, _tmp5_, old_val, 0);
	_tmp6_ = self->board;
	_tmp7_ = row;
	_tmp8_ = col;
	sudoku_board_remove (_tmp6_, _tmp7_, _tmp8_, FALSE);
	_tmp9_ = row;
	_tmp10_ = col;
	g_signal_emit_by_name (self, "cell-changed", _tmp9_, _tmp10_, old_val, 0);
}


void sudoku_game_undo (SudokuGame* self) {
	g_return_if_fail (self != NULL);
	sudoku_game_apply_stack (self, &self->priv->undostack, &self->priv->redostack);
}


void sudoku_game_redo (SudokuGame* self) {
	g_return_if_fail (self != NULL);
	sudoku_game_apply_stack (self, &self->priv->redostack, &self->priv->undostack);
}


void sudoku_game_reset (SudokuGame* self) {
	GTimer* _tmp0_ = NULL;
	GeeArrayList* _tmp1_ = NULL;
	GeeArrayList* _tmp2_ = NULL;
	SudokuBoard* _tmp29_ = NULL;
	GeeSet* _tmp30_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->timer;
	g_timer_reset (_tmp0_);
	_tmp1_ = self->priv->undostack;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
	_tmp2_ = self->priv->redostack;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp2_);
	{
		gint l1 = 0;
		l1 = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint _tmp5_ = 0;
				SudokuBoard* _tmp6_ = NULL;
				gint _tmp7_ = 0;
				gint _tmp8_ = 0;
				if (!_tmp3_) {
					gint _tmp4_ = 0;
					_tmp4_ = l1;
					l1 = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = l1;
				_tmp6_ = self->board;
				_tmp7_ = sudoku_board_get_rows (_tmp6_);
				_tmp8_ = _tmp7_;
				if (!(_tmp5_ < _tmp8_)) {
					break;
				}
				{
					gint l2 = 0;
					l2 = 0;
					{
						gboolean _tmp9_ = FALSE;
						_tmp9_ = TRUE;
						while (TRUE) {
							gint _tmp11_ = 0;
							SudokuBoard* _tmp12_ = NULL;
							gint _tmp13_ = 0;
							gint _tmp14_ = 0;
							SudokuBoard* _tmp15_ = NULL;
							gboolean* _tmp16_ = NULL;
							gint _tmp16__length1 = 0;
							gint _tmp16__length2 = 0;
							gint _tmp17_ = 0;
							gint _tmp18_ = 0;
							gboolean _tmp19_ = FALSE;
							if (!_tmp9_) {
								gint _tmp10_ = 0;
								_tmp10_ = l2;
								l2 = _tmp10_ + 1;
							}
							_tmp9_ = FALSE;
							_tmp11_ = l2;
							_tmp12_ = self->board;
							_tmp13_ = sudoku_board_get_cols (_tmp12_);
							_tmp14_ = _tmp13_;
							if (!(_tmp11_ < _tmp14_)) {
								break;
							}
							_tmp15_ = self->board;
							_tmp16_ = _tmp15_->is_fixed;
							_tmp16__length1 = _tmp15_->is_fixed_length1;
							_tmp16__length2 = _tmp15_->is_fixed_length2;
							_tmp17_ = l1;
							_tmp18_ = l2;
							_tmp19_ = _tmp16_[(_tmp17_ * _tmp16__length2) + _tmp18_];
							if (!_tmp19_) {
								SudokuBoard* _tmp20_ = NULL;
								gint _tmp21_ = 0;
								gint _tmp22_ = 0;
								gint _tmp23_ = 0;
								gint _tmp24_ = 0;
								SudokuBoard* _tmp25_ = NULL;
								gint _tmp26_ = 0;
								gint _tmp27_ = 0;
								gint _tmp28_ = 0;
								_tmp20_ = self->board;
								_tmp21_ = l1;
								_tmp22_ = l2;
								sudoku_board_remove (_tmp20_, _tmp21_, _tmp22_, FALSE);
								_tmp23_ = l1;
								_tmp24_ = l2;
								_tmp25_ = self->board;
								_tmp26_ = l1;
								_tmp27_ = l2;
								_tmp28_ = sudoku_board_get (_tmp25_, _tmp26_, _tmp27_);
								g_signal_emit_by_name (self, "cell-changed", _tmp23_, _tmp24_, _tmp28_, 0);
							}
						}
					}
				}
			}
		}
	}
	_tmp29_ = self->board;
	_tmp30_ = _tmp29_->broken_coords;
	gee_collection_clear ((GeeCollection*) _tmp30_);
}


void sudoku_game_cell_changed_cb (SudokuGame* self, gint row, gint col, gint old_val, gint new_val) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = row;
	_tmp1_ = col;
	_tmp2_ = old_val;
	_tmp3_ = new_val;
	g_signal_emit_by_name (self, "cell-changed", _tmp0_, _tmp1_, _tmp2_, _tmp3_);
}


void sudoku_game_update_undo (SudokuGame* self, gint row, gint col, gint old_val, gint new_val) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	GeeArrayList* _tmp3_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = row;
	_tmp1_ = col;
	_tmp2_ = old_val;
	sudoku_game_add_to_stack (self, &self->priv->undostack, _tmp0_, _tmp1_, _tmp2_);
	_tmp3_ = self->priv->redostack;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp3_);
}


static void sudoku_game_add_to_stack (SudokuGame* self, GeeArrayList** stack, gint r, gint c, gint v) {
	SudokuGameUndoItem step = {0};
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	SudokuGameUndoItem _tmp3_ = {0};
	GeeArrayList* _tmp4_ = NULL;
	SudokuGameUndoItem _tmp5_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (*stack != NULL);
	_tmp0_ = r;
	_tmp1_ = c;
	_tmp2_ = v;
	_tmp3_.row = _tmp0_;
	_tmp3_.col = _tmp1_;
	_tmp3_.val = _tmp2_;
	step = _tmp3_;
	_tmp4_ = *stack;
	_tmp5_ = step;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, &_tmp5_);
}


static void sudoku_game_apply_stack (SudokuGame* self, GeeArrayList** from, GeeArrayList** to) {
	GeeArrayList* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	SudokuGameUndoItem* top = NULL;
	GeeArrayList* _tmp3_ = NULL;
	GeeArrayList* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gpointer _tmp7_ = NULL;
	gint old_val = 0;
	SudokuBoard* _tmp8_ = NULL;
	SudokuGameUndoItem* _tmp9_ = NULL;
	gint _tmp10_ = 0;
	SudokuGameUndoItem* _tmp11_ = NULL;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
	SudokuGameUndoItem* _tmp14_ = NULL;
	gint _tmp15_ = 0;
	SudokuGameUndoItem* _tmp16_ = NULL;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	SudokuBoard* _tmp19_ = NULL;
	SudokuGameUndoItem* _tmp20_ = NULL;
	gint _tmp21_ = 0;
	SudokuGameUndoItem* _tmp22_ = NULL;
	gint _tmp23_ = 0;
	SudokuGameUndoItem* _tmp24_ = NULL;
	gint _tmp25_ = 0;
	SudokuGameUndoItem* _tmp33_ = NULL;
	gint _tmp34_ = 0;
	SudokuGameUndoItem* _tmp35_ = NULL;
	gint _tmp36_ = 0;
	gint _tmp37_ = 0;
	SudokuGameUndoItem* _tmp38_ = NULL;
	gint _tmp39_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (*from != NULL);
	g_return_if_fail (*to != NULL);
	_tmp0_ = *from;
	_tmp1_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == 0) {
		return;
	}
	_tmp3_ = *from;
	_tmp4_ = *from;
	_tmp5_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp3_, _tmp6_ - 1);
	top = (SudokuGameUndoItem*) _tmp7_;
	_tmp8_ = self->board;
	_tmp9_ = top;
	_tmp10_ = (*_tmp9_).row;
	_tmp11_ = top;
	_tmp12_ = (*_tmp11_).col;
	_tmp13_ = sudoku_board_get (_tmp8_, _tmp10_, _tmp12_);
	old_val = _tmp13_;
	_tmp14_ = top;
	_tmp15_ = (*_tmp14_).row;
	_tmp16_ = top;
	_tmp17_ = (*_tmp16_).col;
	_tmp18_ = old_val;
	sudoku_game_add_to_stack (self, to, _tmp15_, _tmp17_, _tmp18_);
	_tmp19_ = self->board;
	_tmp20_ = top;
	_tmp21_ = (*_tmp20_).row;
	_tmp22_ = top;
	_tmp23_ = (*_tmp22_).col;
	sudoku_board_remove (_tmp19_, _tmp21_, _tmp23_, FALSE);
	_tmp24_ = top;
	_tmp25_ = (*_tmp24_).val;
	if (_tmp25_ != 0) {
		SudokuBoard* _tmp26_ = NULL;
		SudokuGameUndoItem* _tmp27_ = NULL;
		gint _tmp28_ = 0;
		SudokuGameUndoItem* _tmp29_ = NULL;
		gint _tmp30_ = 0;
		SudokuGameUndoItem* _tmp31_ = NULL;
		gint _tmp32_ = 0;
		_tmp26_ = self->board;
		_tmp27_ = top;
		_tmp28_ = (*_tmp27_).row;
		_tmp29_ = top;
		_tmp30_ = (*_tmp29_).col;
		_tmp31_ = top;
		_tmp32_ = (*_tmp31_).val;
		sudoku_board_insert (_tmp26_, _tmp28_, _tmp30_, _tmp32_, FALSE);
	}
	_tmp33_ = top;
	_tmp34_ = (*_tmp33_).row;
	_tmp35_ = top;
	_tmp36_ = (*_tmp35_).col;
	_tmp37_ = old_val;
	_tmp38_ = top;
	_tmp39_ = (*_tmp38_).val;
	g_signal_emit_by_name (self, "cell-changed", _tmp34_, _tmp36_, _tmp37_, _tmp39_);
	_sudoku_game_undo_item_free0 (top);
}


gdouble sudoku_game_get_total_time_played (SudokuGame* self) {
	gdouble result = 0.0;
	SudokuBoard* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	GTimer* _tmp3_ = NULL;
	gdouble _tmp4_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->board;
	_tmp1_ = sudoku_board_get_previous_played_time (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->timer;
	_tmp4_ = g_timer_elapsed (_tmp3_, NULL);
	result = _tmp2_ + _tmp4_;
	return result;
}


static void g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__INT_INT_INT_INT) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gint arg_4, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 5);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT_INT_INT_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), g_value_get_int (param_values + 4), data2);
}


static SudokuGameUndoItem* sudoku_game_undo_item_dup (const SudokuGameUndoItem* self) {
	SudokuGameUndoItem* dup;
	dup = g_new0 (SudokuGameUndoItem, 1);
	memcpy (dup, self, sizeof (SudokuGameUndoItem));
	return dup;
}


static void sudoku_game_undo_item_free (SudokuGameUndoItem* self) {
	g_free (self);
}


static GType sudoku_game_undo_item_get_type (void) {
	static volatile gsize sudoku_game_undo_item_type_id__volatile = 0;
	if (g_once_init_enter (&sudoku_game_undo_item_type_id__volatile)) {
		GType sudoku_game_undo_item_type_id;
		sudoku_game_undo_item_type_id = g_boxed_type_register_static ("SudokuGameUndoItem", (GBoxedCopyFunc) sudoku_game_undo_item_dup, (GBoxedFreeFunc) sudoku_game_undo_item_free);
		g_once_init_leave (&sudoku_game_undo_item_type_id__volatile, sudoku_game_undo_item_type_id);
	}
	return sudoku_game_undo_item_type_id__volatile;
}


static void sudoku_game_class_init (SudokuGameClass * klass) {
	sudoku_game_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SudokuGamePrivate));
	G_OBJECT_CLASS (klass)->finalize = sudoku_game_finalize;
	g_signal_new ("cell_changed", TYPE_SUDOKU_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT_INT, G_TYPE_NONE, 4, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT);
}


static void sudoku_game_instance_init (SudokuGame * self) {
	self->priv = SUDOKU_GAME_GET_PRIVATE (self);
}


static void sudoku_game_finalize (GObject* obj) {
	SudokuGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_GAME, SudokuGame);
	_g_object_unref0 (self->board);
	_g_timer_destroy0 (self->timer);
	_g_object_unref0 (self->priv->undostack);
	_g_object_unref0 (self->priv->redostack);
	G_OBJECT_CLASS (sudoku_game_parent_class)->finalize (obj);
}


GType sudoku_game_get_type (void) {
	static volatile gsize sudoku_game_type_id__volatile = 0;
	if (g_once_init_enter (&sudoku_game_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SudokuGameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuGame), 0, (GInstanceInitFunc) sudoku_game_instance_init, NULL };
		GType sudoku_game_type_id;
		sudoku_game_type_id = g_type_register_static (G_TYPE_OBJECT, "SudokuGame", &g_define_type_info, 0);
		g_once_init_leave (&sudoku_game_type_id__volatile, sudoku_game_type_id);
	}
	return sudoku_game_type_id__volatile;
}



